########################################################################################
# Calendar.pl (SP1) v2.1                               # NOTES                         #
# Created by        : jaska (jarno@jokinen.as)         # When you edit something,      #
#                     throesch (Mthroesch@hotmail.com) # please update VERSION CONTROL #
#                     Mathar (mathartg@yahoo.com)      # and UPDATES.                  #
########################################################                               #
# VERSION CONTROL                                      #                               #
# Modified From:  v2.0                                 #                               #
# Modified By:    Throesch                             #                               #
# Modified For:   v2.1				       #                               #
########################################################################################
# UPDATES (v0.2):
# 1) Version controlling added
# 2) The link from boardindex to this day in calendar works now
# 3) Smileys can be disabled from Calendar event
# 4) All the dates in ACRONYM TITLE -tag end with 'st', 'nd', 'rd' or 'th'
# 5) calendar.txt file is not needed for installing. It will be made when needed
# 6) Changed the months in calendar to textual version
# 7) Changed the textbox to a textfield.
# UPdates By throesch (MLT) (v0.3):
# 1) Admin can have only one Month displayed in full.
# 2) If one month is selected calpast is auto set to 0.
# 3) Readded Put Calendar icon in menu.
# 4) code for one month cut by 98% runs better.
# 5) fixed the small calendar icon problem to show big calendar.(calendar2.gif replaced
#    by calendar.gif. LOOKS BETTER THAT WAY. )
# 6) fixed the alt=display and new posts to display right (1st jan, 2002 now reads 
#	 jan 1st, 2002
# UPDATES By Mathar (MRH) (v0.4):
# 1) Added setting to show calendar at top of board index
#			(get_settings;cal_save_settings;caladmin)
# 2) Added setting for display upcoming events in number of days; 0 for standard display
#			(get_settings;cal_save_settings;caladmin)
# 3) Modified one month display cosmetics
#			(cal_month)
# 4) Modified view from boardindex to list events
#			(calendar_index)
# UPDATES By throesch (MLT) (v0.5):
# 1) cosmetics done to one month for better navigations.
# 2) readded day highight to admin function with on/off feature.
# 3) cleaned up code (fixed admin section and way admin saved is now in order).
# 4) fixed red sundays.
# 5) fixed calindex now lines up.
# UPDATES By throesch (MLT) (v2.1):
# 1) Added a mini calendar to the front(board index)
# 2) fixed a small bug in the menu for the calendar
# 3) added a admin control for the mini calendar
# 4) readded the icons for bday, event, holidays.
########################################################################################

$Calendarver= "2.1";
sub cal_list {
	require "$sourcedir/Subs.pl";
	use Time::Local;
	&get_settings;
	($secA,$minA,$hourA,$mdayA,$monA,$yearA,$wdayA,$ydayA,$isdstA) = localtime(time + (3600*($timeoffset+$settings[18])));

	$yearstart = $yearA+1900;
	$displaymonths=$calpast+$calfuture;
	$monthstart=1+$monA-$calpast;
	$monthend=1+$monA+$calfuture;
	while ($monthstart <= 0) {
		$monthstart+=12;
		$yearstart-=1;
	}
	&make_note_array;
	&get_event;
	while (($nextnote) && (($n_year < $yearstart) || (($n_year == $yearstart) && ($n_month < $monthstart))))
		{&get_event;}

	$yymain .= "<table width=\"100%\" cellspacing=\"5\">\n<tr>\n<td valign=top>";
	for ($z=0; $z<$displaymonths; $z++) {
		$displayyear=$yearstart;
		$displaymonth=$monthstart+$z;
		while ($displaymonth >= 13) {
			$displaymonth-=12;
			$displayyear++;
		}
		if (length($displayyear)== 1) {$displayyear="0$displayyear";}
		if (length($displaymonth)== 1) {$displaymonth="0$displaymonth";}
		if (($z+1)%$calwidth == 1 && $z >= 1)
			{$yymain .= "</td>\n  </tr>\n  <tr>\n    <td valign=top>";}
		elsif ($z > 0)
			{$yymain .= "</td>\n    <td valign=top>";}
			&drawcal;
		}
	$yymain .= "\n</table>\n<p align=\"center\"><a href=\"$cgi\">$txt{'193'}</a></p>\n";
	&template;
	exit;
}

sub drawcal {
	$yytitle = "$caltxt{'1'}";
	$mon = $displaymonth-1;
	$year = $displayyear;
	@months2 = ('January','February','March','April','May','Jun','July','August','September','October','November','December');
	$days_in_month = &days_in_month();
	($temp,$temp,$temp,$temp,$temp,$temp,$wday,$temp,$temp) = localtime(timegm(0,0,0,1,$mon,$year));
	$pvm = 1-$wday;
	if ($dayoffset == 1) # Offset
		{$pvm--;}
	$displayyear=substr($displayyear,-2);
	$monthyear = @months2[$mon]." ".$year;
	$monthyear1 = @months2[$mon];
	$monthyear2 = ", ".$year;
	if ($onemonth == 1) {
	$yySetLocation = qq~$cgi;action=calendar2;viewmonth=$displaymonth;viewyear=$displayyear~;
	&redirectexit;
	}else{
	$yymain .= qq~
<TABLE WIDTH=210 CELLSPACING=0 CELLPADDING=0 BORDER=0 COLS=7>
  <TR HEIGHT=20>
    <TD COLSPAN=7 CLASS="catbg" ALIGN=center VALIGN=middle>
	<A HREF="$cgi;action=calendar2;viewmonth=$displaymonth;viewyear=$displayyear" TITLE="$caltxt{'6'} $monthyear">$monthyear</A>
    </TD>
  </TR>
  <TR HEIGHT=20>
~;
	for ($i=0;$i<7;$i++)
		{$yymain .= "    <TD CLASS=\"titlebg\" WIDTH=30 align=center valign=middle>".substr(@days[$i],0,2)."</TD>\n";}
	$yymain .= "  </TR>\n";
	while ($pvm <= $days_in_month) {
		$yymain .= "  <TR HEIGHT=20>\n";
		for ($weekdaycounter=0;$weekdaycounter<7;$weekdaycounter++) {
			if ($pvm >= 1 && $pvm <= $days_in_month) {
				$displayday = $pvm < 10 ? "0".$pvm : $pvm;
				$paivays = $displayyear.$displaymonth.$displayday;

				$class = "normal";
				$style = "font-size=11px;";
				$pvm_text = $pvm;
				$number = $pvm;
				$pvm_seq = &serial_number();

			DATECHECK:
				if (($nextnote) && ($n_date eq $paivays)) {
				    if ($SMI == 1) {					
					if ($n_type eq "BD") {
						$style .= " background-image:URL('$imagesdir/birthday_small.gif'); background-repeat:no-repeat;";
						$class = "birthday";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "HO") {
						$style .= " background-image:URL('$imagesdir/holiday_small.gif'); background-repeat:no-repeat;";
						$class = "note";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "NO") {
						$style .= " background-image:URL('$imagesdir/note_small.gif'); background-repeat:no-repeat;";
						$class = "note";
						$pvm_text = "$pvm";
					}
				    } else {
					if ($n_type eq "BD") {
						$class = "birthday";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "HO") {
						$class = "note";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "NO") {
						$class = "note";
						$pvm_text = "$pvm";
					}
				    }

					&get_event;
					goto DATECHECK;
				}

				elsif (($mdayA == $pvm) && (($monA+1) == $displaymonth) && (($yearA-100) == $displayyear)) {
					$class = "today";
					$pvm_text = "<U>".$pvm_text."</U>";
				}
				$pvm_text = (($red_sundays == 1) && ($weekdaycounter == 0)) ? "<FONT COLOR=#FF0000> ".$pvm_text." </FONT>" : " ".$pvm_text." ";
				$day_link = qq~<A HREF="$cgi;action=calendar3;viewday=20$paivays" TITLE="$txt{'305'} $monthyear1 $pvm_seq$monthyear2">$pvm_text</A>~;
				$yymain .= "    <TD CLASS=\"$class\" STYLE=\"$style\" HEIGHT=\"32\" WIDTH=\"30\" ALIGN=\"center\" VALIGN=\"middle\">$day_link</TD>";
			}
			elsif ($floating_calendar == 1)
				{$yymain .= " 	 <TD HEIGHT=\"1\" WIDTH=\"30\"></TD>\n";}
			else
				{$yymain .= "    <TD CLASS=\"normal\" HEIGHT=\"1\" WIDTH=\"30\"> </TD>\n";}
			$pvm++;
		}
		$yymain .= "  </TR>\n";
	}
	$yymain .= "</TABLE>\n";
  }
}

sub days_in_month() {
	if ($mon == 0) {return 31;}
	if ($mon == 1) {
		if ($year%4 == 0) {
			if ($year%100 == 0) {
				if ($year%400 == 0) {
					return 29;
				}
				return 28;
			}
			return 29;
		}
		return 28;
	}
	if ($mon == 2) {return 31;}
	if ($mon == 3) {return 30;}
	if ($mon == 4) {return 31;}
	if ($mon == 5) {return 30;}
	if ($mon == 6) {return 31;}
	if ($mon == 7) {return 31;}
	if ($mon == 8) {return 30;}
	if ($mon == 9) {return 31;}
	if ($mon == 10) {return 30;}
	if ($mon == 11) {return 31;}
}

sub serial_number() {
	if ((($number > 3) && ($number < 21)) || (($number > 23) && ($number < 31))) {
		return $number.$caltxt{'15'};
	} elsif (substr($number,-1) eq "1") {
		return $number.$caltxt{'12'};
	} elsif (substr($number,-1) eq "2") {
		return $number.$caltxt{'13'};
	} elsif (substr($number,-1) eq "3") {
		return $number.$caltxt{'14'};
	}
}

sub cal_month {
	require "$sourcedir/Subs.pl";
	&timeformat($date);
	($month, $day, $year) = split(/\//, $date);
	($year, $trash) = split(/ /, $year);
	&get_settings;
	$viewmonth = $INFO{'viewmonth'};
	chomp $viewmonth;
	if (length($viewmonth) == 1)
		{$viewmonth="0$viewmonth";}
	$viewyear = $INFO{'viewyear'};
	chomp $viewyear;
	if (length($viewyear) == 1)
		{$viewyear="0$viewyear";}

	($secA,$minA,$hourA,$mdayA,$monA,$yearA,$wdayA,$ydayA,$isdstA) = localtime(time + (3600*($timeoffset+$settings[18])));
	$yearA+=1900;
	$mon = $viewmonth-1;
	$year = $viewyear>50 ? "19".$viewyear : "20".$viewyear;
	$days_in_month = &days_in_month();
	($temp,$temp,$temp,$temp,$temp,$temp,$wday,$temp,$temp) = localtime(timegm(0,0,0,1,$mon,$year));
	$pvm = 1-$wday;
	if ($dayoffset == 1) # Offset
		{$pvm--;}
	@months2 = ('January','February','March','April','May','Jun','July','August','September','October','November','December');
	$monthyear = @months2[$mon]."  ".$year;
	$monthyear1 = @months2[$mon];
	$monthyear2 = ", ".$year;
	&make_note_array;
	&get_event;
	while (($nextnote) && (($n_year < $year) || (($n_year == $year) && ($n_month < $viewmonth))))
		{&get_event;}

	$prev_month = $viewmonth==1 ? "12" : $viewmonth-1;
	$next_month = $viewmonth==12 ? "1" : $viewmonth+1;
	$prev_year = $viewmonth==1 ? substr(($year-1),2,2) : substr($year,2,2);
	$next_year = $viewmonth==12 ? substr(($year+1),2,2) : substr($year,2,2);

	$prevmonthlink = qq~<a href=$cgi;action=calendar2;viewmonth=$prev_month;viewyear=$prev_year title=\"$txt{'305'} @months2[$prev_month-1] $prev_year\"><< </a>~;
	$nextmonthlink = qq~<a href=$cgi;action=calendar2;viewmonth=$next_month;viewyear=$next_year title=\"$txt{'305'} @months2[$next_month-1] $next_year\"> >></a>~;
	
	$viewyearfuture = substr(($year+1),2,2);
	$viewyearpast = substr(($year-1),2,2); 

	$pyear = $year-1;
	$fyear = $year+1;

	$prevyearlink = qq~<a href=$cgi;action=calendar2;viewmonth=$viewmonth;viewyear=$viewyearpast title=\"$txt{'305'} year $pyear\"><< </a>~;
	$nextyearlink = qq~<a href=$cgi;action=calendar2;viewmonth=$viewmonth;viewyear=$viewyearfuture title=\"$txt{'305'} year $fyear\"> >></a>~;

	$yymain .= qq~
		<table border=0 width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
		<tr>
		<td><table cellpadding="4" cellspacing="1" border="0" width="100%">
		<TR HEIGHT=30>
		<TD CLASS="catbg" COLSPAN=7>
	    <TABLE WIDTH=100% CELLSPACING=0 CELLPADDING=0 BORDER=0 COLS=3>
		<TR>
		<TD WIDTH="30" ALIGN="center" VALIGN="middle"><A HREF="$cgi;action=calendar"><IMG SRC="$imagesdir/calendar.gif" ALT="calendar" BORDER="0"></A></TD>
		~;
		if ($onemonth == 1) {$yymain .= qq~
			<td width="640" COLSPAN=5 ALIGN=center VALIGN=middle>
			<FONT SIZE=3>$prevyearlink</font>
			<select name="values" onChange="if(this.options[this.selectedIndex].value) window.location.href='' + this.options[this.selectedIndex].value;"class="catbg">
			<option value="" class="" selected>@months2[$mon] $year</option>
			<option value="$cgi;action=calendar2;viewmonth=01;viewyear=$viewyear" class="" >January</option>
			<option value="$cgi;action=calendar2;viewmonth=02;viewyear=$viewyear" class="" >February</option>
			<option value="$cgi;action=calendar2;viewmonth=03;viewyear=$viewyear" class="" >March</option>
			<option value="$cgi;action=calendar2;viewmonth=04;viewyear=$viewyear" class="" >April</option>
			<option value="$cgi;action=calendar2;viewmonth=05;viewyear=$viewyear" class="" >May</option>
			<option value="$cgi;action=calendar2;viewmonth=06;viewyear=$viewyear" class="" >June</option>
			<option value="$cgi;action=calendar2;viewmonth=07;viewyear=$viewyear" class="" >July</option>
			<option value="$cgi;action=calendar2;viewmonth=08;viewyear=$viewyear" class="" >August</option>
			<option value="$cgi;action=calendar2;viewmonth=09;viewyear=$viewyear" class="" >September</option>
			<option value="$cgi;action=calendar2;viewmonth=10;viewyear=$viewyear" class="" >October</option>
			<option value="$cgi;action=calendar2;viewmonth=11;viewyear=$viewyear" class="" >November</option>
			<option value="$cgi;action=calendar2;viewmonth=12;viewyear=$viewyear" class="" >December</option>
			</select><FONT SIZE=3>$nextyearlink</font></td>
		~;} else {$yymain .= qq~
		<TD WIDTH="640" COLSPAN=5 ALIGN=center VALIGN=middle>$prevmonthlink<A HREF="$cgi;action=calendar" TITLE="$caltxt{'1'}"><b>$monthyear</b></A>$nextmonthlink</TD>
		~;}
		$yymain .= qq~
			</TR></TABLE></TD>
			</TR><TR HEIGHT=10>
~;

	for ($i=0;$i<7;$i++)
		{$yymain .= "    <TD CLASS=\"catbg\" WIDTH=14% align=center valign=middle>".@days[$i]."</TD>\n";}
	$yymain .= "  </TR>\n";
	$yymain .= qq~<TR HEIGHT="90">~;

	while ($pvm <= $days_in_month)
	{
		for ($weekday = 1; $weekday <= 7; $weekday++)
		{
			if ($pvm >= 1 && $pvm <= $days_in_month) {
				$class = "windowbg2";
				$message = "";
				$pvm_text = $pvm;
				$number = $pvm;
				$pvm_seq = &serial_number();

				$displayday = $pvm < 10 ? "0".$pvm : $pvm;
				$paivays = $viewyear.$viewmonth.$displayday;
				$pvm_text = length($pvm)==1 ? " <B>".$pvm."</B> " : "<B>".$pvm."</B>";
				
				$pvm_text = (($red_sundays == 1) && ($weekday == 1)) ? "<FONT COLOR=#FF0000>".$pvm_text."</FONT>" : $pvm_text;
				$day_link = qq~<A HREF="$cgi;action=calendar3;viewday=20$paivays" TITLE="$txt{'305'} $monthyear1 $pvm_seq$monthyear2 " CLASS=catbg> $pvm_text   </A>~;
				
				$style = " ";
				DATECHECK2:
				if (($nextnote) && ($n_date eq $paivays)) {
				    if ($SMI == 1) {
					if ($n_type eq "BD") {
						$class = "birthday";
						($BDName,$BDYear) = split(/::/, $n_data);
						$style .= "background-image:URL('$imagesdir/birthday_small.gif'); background-repeat:no-repeat;";
						$message .= "<acronym title=\"".$BDName." ".$caltxt{'17'}." ".($year-$BDYear)." ".$caltxt{'18'}."\"><nobr>".$BDName." ".($year-$BDYear)."...</nobr></acronym> \n";
					} elsif ($n_type eq "NO") {
						$class = "note";
						$style .= " background-image:URL('$imagesdir/note_small.gif'); background-repeat:no-repeat;";
						$i=1;
						(@events) = split(/::/, $n_data);
						foreach $event (@events) {
							if (length($event) > 0) {
								if ($i > 4) {
									$message .= "<center><b><acronym title=\"$caltxt{'42'}\">...</acronym></b></center>\n";
									last;
								} else {
									$message .= "<acronym title=\"".$event."\"><nobr>".$i++.". ".substr($event,0,10)."...</nobr></acronym> \n";
								}
							}
						}
					} elsif ($n_type eq "HO") {
						$class = "note";
						$style .= " background-image:URL('$imagesdir/holiday_small.gif'); background-repeat:no-repeat;";
						$message .= "<acronym title=\"".$n_data."\"><nobr>".substr($n_data,0,10)."...</nobr></acronym> \n";
					}
				   } else {
					if ($n_type eq "BD") {
						$class = "birthday";
						($BDName,$BDYear) = split(/::/, $n_data);
						$message .= "<acronym title=\"".$BDName." ".$caltxt{'17'}." ".($year-$BDYear)." ".$caltxt{'18'}."\"><nobr>".$BDName." ".($year-$BDYear)."...</nobr></acronym> \n";
					} elsif ($n_type eq "NO") {
						$class = "note";
						$i=1;
						(@events) = split(/::/, $n_data);
						foreach $event (@events) {
							if (length($event) > 0) {
								if ($i > 4) {
									$message .= "<center><b><acronym title=\"$caltxt{'42'}\">...</acronym></b></center>\n";
									last;
								} else {
									$message .= "<acronym title=\"".$event."\"><nobr>".$i++.". ".substr($event,0,10)."...</nobr></acronym> \n";
								}
							}
						}
					} elsif ($n_type eq "HO") {
						$class = "note";
						$message .= "<acronym title=\"".$n_data."\"><nobr>".substr($n_data,0,10)."...</nobr></acronym> \n";
					}
				   }
					&get_event;
					goto DATECHECK2;
				}

				if ($hlightday == 1) {
					if (($mdayA == $pvm) && ($monA == $mon) && ($yearA == $year))
				{$class = "windowbg";}
				}
				else {
					if (($day == $pvm) && ($viewmonth == $month) && ($viewyear == $year))
				{$class = "today2";}
				}
			}
			else {
				$class = "windowbg2";
				$style = " ";
				$day_link = " ";
				$message = " ";
			}
 
			if ($displayday == "")
			{$yymain .= qq~<TD CLASS=$class HEIGHT="1"></TD>~;}
			else
			{$yymain .= qq~<TD CLASS=$class STYLE="$style" VALIGN="top"><B>$day_link</B>$message</TD>~;}
			
			$pvm++;
		}
		
		if ($pvm <= $days_in_month)
			{ $yymain .= qq~</TR><TR HEIGHT="90">~; }
	}
	$yymain .= qq~
	</TR></table>
	</td></tr>
	</table>
	~;
if ($onemonth == 1) {
	$yymain .= qq~
~;
} else {
	$yymain .= qq~
<p align="center"><a href=$cgi;action=calendar>$txt{'193'}</a></p>
~;}
	if ($onemonth == 1) {
	$yytitle = "$caltxt{'1'} year,  $year";
	}else{
	$yytitle = $caltxt{'1'};
	}
	&template;
	exit;
}

sub cal_modify {
	&get_settings;
	$displayday = $passedday == 0 ? $INFO{'viewday'} : $passedday;
	$passedday=0;
	$yy=substr($displayday,2,2);
	$yyyy=substr($displayday,0,4);
	$mm=substr($displayday,4,2);
	$dd=substr($displayday,6,2);
	$pvm = substr($displayday,4,4);
	$mon=$mm-1;
	if ($dd == 1) {
		if ($mm == 1) {
			$prev_year = $yyyy-1;
			$prev_mon = "12";
			$prev_day = "31";
		}
		else {
			$prev_year = $yyyy;
			$prev_mon = $mm-1;
			$prev_mon = length($prev_mon) > 1 ? $prev_mon : "0".$prev_mon;
			$mon--;
			$prev_day = &days_in_month();
			$mon++;
			$prev_day = length($prev_day) > 1 ? $prev_day : "0".$prev_day;
		}
	} else {
		$prev_year = $yyyy;
		$prev_mon = $mm;
		$prev_day = $dd-1;
		$prev_day = length($prev_day) > 1 ? $prev_day : "0".$prev_day;
	}
	$prev_date = $prev_year.$prev_mon.$prev_day;

	if (&days_in_month() == $dd) {
		if ($mm == 12) {
			$next_day = "01";
			$next_mon = "01";
			$next_year = $yyyy+1;
		}
		else {
			$next_year = $yyyy;
			$next_mon = $mm+1;
			$next_mon = length($next_mon) > 1 ? $next_mon : "0".$next_mon;
			$next_day .= "01";
		}
	} else {
		$next_year = $yyyy;
		$next_mon = $mm;
		$next_day = $dd+1;
		$next_day = length($next_day) > 1 ? $next_day : "0".$next_day;
	}
	$next_date = $next_year.$next_mon.$next_day;

	$prev_day = $prev_day<10&&length($prev_day)>1?substr($prev_day,-1,1):$prev_day;	# If previous date contains '0' as first char, remove it
	$number = $prev_day; $prev_day = serial_number();								# Add 'st', 'nd', 'rd' or 'th' at the end of previous date
#	$prev_mon = $prev_mon<10&&length($prev_mon)>1?substr($prev_mon,-1,1):$prev_mon;	# If previous month contains '0' as first char, remove it
	$prev_mon = @months[($prev_mon-1)];												# Change previous month to text
	$next_day = $next_day<10&&length($next_day)>1?substr($next_day,-1,1):$next_day;	# If next date contains '0' as first char, remove it
	$number = $next_day; $next_day = serial_number();								# Add 'st', 'nd', 'rd' or 'th' at the end of next date
#	$next_mon = $next_mon<10&&length($next_mon)>1?substr($next_mon,-1,1):$next_mon;	# If next month contains '0' as first char, remove it
	$next_mon = @months[($next_mon-1)];												# Change next month to text

	$prev_date = "<A HREF=\"$cgi;action=calendar3;viewday=$prev_date\" TITLE=\"$txt{'305'} ".$prev_mon." ".$prev_day.", ".$prev_year."\">&lt&lt</A>";
	$next_date = "<A HREF=\"$cgi;action=calendar3;viewday=$next_date\" TITLE=\"$txt{'305'} ".$next_mon." ".$next_day.", ".$next_year."\">&gt&gt</A>";
	if ($dd == 1 || $dd == 21 || $dd == 31)
		{$datewords=$caltxt{'12'};}
	elsif ($dd == 2 || $dd == 22)
		{$datewords=$caltxt{'13'};}
	elsif ($dd == 3 || $dd == 23)
		{$datewords=$caltxt{'14'};}
	else
		{$datewords=$caltxt{'15'};}
	if($dd <= 9)
		{$dd=substr($dd,1,1);}
	$displaymonth=$mm;
	$monthname = @months[($mm-1)];
	if ($displaymonth == 1) {$vm ="January";}
	if ($displaymonth == 2) {$vm ="February";}
	if ($displaymonth == 3) {$vm ="March";}
	if ($displaymonth == 4) {$vm ="April";}
	if ($displaymonth == 5) {$vm ="May";}
	if ($displaymonth == 6) {$vm ="June";}
	if ($displaymonth == 7) {$vm ="July";}
	if ($displaymonth == 8) {$vm ="August";}
	if ($displaymonth == 9) {$vm ="September";}
	if ($displaymonth == 10) {$vm ="October";}
	if ($displaymonth == 11) {$vm ="November";}
	if ($displaymonth == 12) {$vm ="December";}	
	$monthlink=qq~<a href=$cgi;action=calendar2;viewmonth=$displaymonth;viewyear=$yy title=\"$txt{'305'} $vm\">$monthname</a>~;
	my $dayhold="$dd$datewords";
	if ($show_birthdays == 1) {
		open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
		@members = <FILE>;
		close(FILE);
		foreach $usernames (@members) {
			chomp $usernames;
			open(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			close(FILE);
			chomp $userbd[1];
			chomp $userbd[16];
			if ($userbd[16]) {
				($usermonth, $userday, $useryear) = split(/\//, $userbd[16]);
				if ($usermonth.$userday == $pvm) {
					$age = $yyyy-$useryear;
					$string = qq~
  <TR>
    <TD CLASS="birthday" ALIGN="center" VALIGN="middle"><IMG SRC="$imagesdir/cal_birthday.gif" ALT="$txt{'563'}"></TD>
    <TD CLASS="birthday" VALIGN="middle">$userbd[1] $caltxt{'17'} $age $caltxt{'18'}</TD>
    <TD CLASS="birthday" ALIGN="center" VALIGN="middle">$txt{'2'}</TD>
  <TR>~;
					push (@events, $string);
				}
			}
		}
	}

	if (open(HOLIDAYS, "$vardir/calendar/holidays.txt")) {
		@holidays = <HOLIDAYS>;
		close(HOLIDAYS);
		foreach $holiday (@holidays) {
			chomp $holiday;
			($holi_date, $holi_day) = split(/\|/, $holiday);
			if ((length($holi_date) == 8) && ($yyyy == substr($holi_date,0,4)))
				{$holi_date = substr($holi_date,-4);}
			if ($holi_date eq $pvm) {
				$string = qq~
  <TR>
    <TD CLASS="note" ALIGN="center" VALIGN="middle"><IMG SRC="$imagesdir/cal_holiday.gif" ALT="$caltxt{'39'}"></TD>
    <TD CLASS="note" VALIGN="middle">$holi_day</TD>
    <TD CLASS="note" ALIGN="center" VALIGN="middle">$txt{'2'}</TD>
  <TR>~;
				push (@events, $string);
			}
		}
	}

	if (open(TIEDOSTO, "$vardir/calendar/$displayday.evt")) {
		$i=0;
		while (<TIEDOSTO>) {
			chomp;
			$event_type = "";
			($message,$composer,$private,$nosmileys) = split(/\|/);
			if (($allowprivate==0) || (($allowprivate==1) && (($private == 0) || ($composer eq $username) || ($settings[7] eq "Administrator")))) {
				$i++;
				$preubbcmessage = $message;
				if($enable_ubbc && ($nosmileys != 1)) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
				$composer_link = ($composer ne "Guest") ? "<a href=\"$scripturl?board=;action=viewprofile;username=$composer\"><font size=\"2\">$composer</font></a>" : $composer;
				if (($allowprivate == 1) && ($private == 1))
					{$event_type = "<b>".$caltxt{'40'}."</b>";}
				if (($username eq $composer) || ($settings[7] eq "Administrator")) {
					$composer = qq~
<table cellspacing="2" cellpadding="0" border="0" align="center" valign="middle">
<form action="$cgi;action=calendar5;viewday=$displayday;message=$i" method="post" name="m$i" onSubmit="submitonce(this);">
  <tr>
    <td><center>$composer_link</center></td>
  </tr>
  <tr>
    <td>
    <input class="normal" type="submit" value="$txt{'121'}">
    <input type="hidden" name="message$i" hspace="0" vspace="0" value="$preubbcmessage">
    </td>
  </tr>
</form>
</table>~;
				}
				if ($i == 1)
					{$nootti = "<IMG SRC=\"$imagesdir/cal_note.gif\" ALT=\"$i$caltxt{'12'} $caltxt{'4'}\">";}
				elsif ($i == 2)
					{$nootti = "<IMG SRC=\"$imagesdir/cal_note.gif\" ALT=\"$i$caltxt{'13'} $caltxt{'4'}\">";}
				elsif ($i == 3)
					{$nootti = "<IMG SRC=\"$imagesdir/cal_note.gif\" ALT=\"$i$caltxt{'14'} $caltxt{'4'}\">";}
				else
					{$nootti = "<IMG SRC=\"$imagesdir/cal_note.gif\" ALT=\"$i$caltxt{'15'} $caltxt{'4'}\">";}
				$string = qq~
  <TR>
    <TD CLASS="normal" ALIGN="center" VALIGN="middle">$nootti</TD>
    <TD CLASS="normal" VALIGN="middle">$message</TD>
    <TD CLASS="normal" ALIGN="center" VALIGN="middle">$event_type$composer</TD>
  <TR>~;
				push (@events, $string);
			}
		}
		close(TIEDOSTO);
	}
	if ($events[0]) {
		$yymain .= qq~
<SCRIPT LANGUAGE="JavaScript1.2" SRC="$ubbcjspath" TYPE="text/javascript"></SCRIPT>
<TABLE CELLPADDING="3" CELLSPACING="0" ALIGN="center" WIDTH="90%">
  <TR>
    <TD CLASS="catbg" WIDTH="5%" ALIGN="center" VALIGN="middle"><A HREF="$cgi;action=calendar"><IMG SRC="$imagesdir/calendar.gif" ALT="$caltxt{'1'}" BORDER=0></A></TD>
    <TD CLASS="catbg" WIDTH="85%" VALIGN="middle">$prev_date $monthlink $dayhold, $yyyy $next_date</TD>
    <TD CLASS="catbg" WIDTH="10%" ALIGN="center" VALIGN="middle">$txt{'279'}:</TD>
  </TR>
~;
		foreach (@events)
			{$yymain .= $_ if (length($_) > 10);}
	}
	else {
		$yymain .= qq~
<SCRIPT LANGUAGE="JavaScript1.2" SRC="$ubbcjspath" TYPE="text/javascript"></SCRIPT>
<TABLE CELLPADDING="3" CELLSPACING="0" ALIGN="center" WIDTH="90%">
  <TR>
    <TD CLASS="catbg" WIDTH="5%" ALIGN="center" VALIGN="middle"><A HREF="$cgi;action=calendar"><IMG SRC="$imagesdir/calendar.gif" ALT="$caltxt{'1'}" BORDER=0></A></TD>
    <TD CLASS="catbg" WIDTH="95%" VALIGN="middle">$prev_date $monthlink $dayhold, $yyyy $next_date</TD>
  </TR>
  <TR>
    <TD COLSPAN="2" CLASS="note" ALIGN="center" VALIGN="middle">$caltxt{'3'}</TD>
  <TR>~;
	}
	if ((($username ne "Guest") || ($calguest == 1)) && (($settings[7] eq "Administrator") || ($admincalendar == 0))) {
		$yymain .= qq~
</TABLE>
<table width="90%" align="center" cellspacing="1" border="0">
   <tr>
    <td class="catbg" width="100%" align="center">$caltxt{'9'}</td>
  </tr>
  <tr>
    <td class="normal" width="100%" align="center" nowrap>
<form action="$cgi;action=calendar4" method="post" name="postmodify" onSubmit="submitonce(this);">
<input type="hidden" name="datetopost" value="$displayday">
<textarea class="input" name="postmessage" maxlength="150" cols="80" rows="6"></textarea>
<!--<input class="input" type="text" name="postmessage" maxlength="60" size="80" value="">-->
~;
		if ($allowprivate == 1)
			{$yymain .= "$caltxt{'40'}? <input type=\"checkbox\" value=\"X\" name=\"private\">\n";}
		$yymain .= qq~
    </td>
  </tr>
  <tr>
    <td class="normal" width="100%" align="center" valign="center">
<font size=2><b>$txt{'276'}:</b></font>
<input type=checkbox name="nosmileys" value="1" checked> <font size="1"> $txt{'277'}</font>
    </td>
  </tr>
  <tr>
    <td class="normal" width="100%" align="center" valign="center">
<input class="input" type="submit" name="addmessage" value="$caltxt{'10'}" align="center" valign="center">
<input class="input" type="reset" value="$txt{'278'}" align="center" valign="center">
</form>
    </td>
  </tr>
~;
	}
	$yymain .= qq~
</TABLE>
<P ALIGN="center"><A HREF="$cgi;action=calendar">$txt{'193'}</A></P>
~;
	$yytitle = "$caltxt{'1'} - $monthname $dayhold, $yyyy";
	&template;
	exit;
}

sub cal_modify2 {
	&get_settings;
	if (($settings[7] ne "Administrator") && ($admincalendar == 1)) {
		$yymain .= "Only Admins are allowed to add Calendar notes!";
		$displayday = $FORM{'datetopost'};
	} elsif (($username eq "Guest") && ($calguest == 0)) {
		$yymain .= "Only Registered Members are allowed to add Calendar notes!";
		$displayday = $FORM{'datetopost'};
	} else {
		$displayday = $FORM{'datetopost'};
		$message = $FORM{'postmessage'};
		$nosmileys = $FORM{'nosmileys'};
		$calprivate = $FORM{'private'};
		$message =~ s/\|/-/g;
		$message =~ s/\n//g;
		$message =~ s/\r//g;
		if (length($message) == 0)
			{&calendarposterror;}
		else
		{
			$filename=$displayday.".evt";
			open(FILE, "$vardir/calendar/$filename");
			@inputfile = <FILE>;
			close(FILE);
			$zzcount=0;
			foreach $totalmessage (@inputfile) {
				($totalmessage,$trash) = split( /\|/, $totalmessage);
				if ($totalmessage eq $message) {
					$zzcount++;
				}
			}
			if ($calprivate eq "X")
				{$calprivate=1;}
			else 
				{$calprivate=0}
			if ($zzcount == 0) {
				fopen(FILE, ">>$vardir/calendar/$filename",1);
				print FILE $message."|".$username."|".$calprivate."|".$nosmileys."\n";
				close(FILE);
				$filename="calendar.txt";
				open (FILE,"$vardir/calendar/$filename");
				@events = <FILE>;
				close(FILE);
				$xxcount = 0;
				foreach $event (@events) {
					if ($event == $displayday)
						{$xxcount++;}
				}
				if ($xxcount == 0) {
					fopen(FILE, ">>$vardir/calendar/$filename",1);
					print FILE $displayday."\n";
					close(FILE);
				}
			}
		}
	}
	$passedday=$displayday;
	&cal_modify;
	exit;
}

sub calendarposterror {
	$yymain .= qq~
<table width="90%" border=0>
  <tr>
    <td class="catbg">$caltxt{'19'}</td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'11'}</td>
  </tr>
</table>
<p align="center"><a href="javascript:history.go(-1);">$txt{'193'}</a></p>
~;
	$yytitle="$caltxt{'19'}";
	&template;
	exit;
}

sub cal_delete_message {
	$messageno=$INFO{'message'};
	$messageno="message".$messageno;
	$deletemessage=$FORM{$messageno};
	$displayday=$INFO{'viewday'};
	chomp $deletemessage;
	$filename=$displayday.".evt";
	open(FILE, "$vardir/calendar/$filename");
	@inputfile = <FILE>;
	close(FILE);
	$goodmessagecount=0;
	foreach $inputentry (@inputfile) {
		($messagex,$postuser) = split( /\|/, $inputentry);
		if ($messagex ne $deletemessage) {
			$goodmessagecount++;
			push(@outputfile,$inputentry);
		}
	}
	if ($goodmessagecount >= 1) {
		fopen(FILE,">$vardir/calendar/$filename",1);
		print FILE @outputfile;
		close(FILE);
	}
	else {
		unlink ("$vardir/calendar/$filename");
		open(FILE,"$vardir/calendar/calendar.txt");
		@inputfile = <FILE>;
		close(FILE);
		foreach $inputentry (@inputfile) {
			if ($inputentry != $displayday)
				{push (@caloutputfile,$inputentry);}
		}
		fopen(FILE,">$vardir/calendar/calendar.txt",1);
		print FILE @caloutputfile;
		close(FILE);
	}
	$viewday=$displayday;
	&cal_modify;
}

sub caladmin {
	&is_admin;
	&get_settings;

	$calguest_c = $calguest == 1 ? " CHECKED" : "";
	$calindex_c = $calindex == 1 ? " CHECKED" : "";
	$caltop_c = $caltop == 1 ? " CHECKED" : "";
	$onemonth_c = $onemonth == 1 ? " CHECKED" : "";
	$hlightday_c = $hlightday == 1 ? " CHECKED" : "";
	$allowprivate_c = $allowprivate == 1 ? " CHECKED" : "";
	$admincalendar_c = $admincalendar == 1 ? " CHECKED" : "";
	$dayoffset_c = $dayoffset == 1 ? " CHECKED" : "";
	$red_sundays_c = $red_sundays == 1 ? " CHECKED" : "";
	$floating_calendar_c = $floating_calendar == 1 ? " CHECKED" : "";
	$show_birthdays_c = $show_birthdays == 1 ? " CHECKED" : "";
        $minical_c = $minical == 1 ? " CHECKED" : "";
	$SMI_c = $SMI == 1 ? " CHECKED" : "";
	$BMC_c = $BMC == 1 ? " CHECKED" : "";
	$HMC_c = $HMC == 1 ? " CHECKED" : "";
	$NMC_c = $NMC == 1 ? " CHECKED" : "";
	$BYC_c = $BYC == 1 ? " CHECKED" : "";
	$HYC_c = $HYC == 1 ? " CHECKED" : "";
	$NYC_c = $NYC == 1 ? " CHECKED" : "";

	$yymain .= qq~
<SCRIPT LANGUAGE="JavaScript1.2" SRC="$ubbcjspath" TYPE="text/javascript"></SCRIPT>
<form action="$cgi;action=calendar7" method="post" name="changecalsetting" onSubmit="submitonce(this);">
<table align="center" border="0" cellspacing="1">
  <tr border=1>
    <td class="titlebg" colspan="5"><font size=2 class="text1" color="#FFFFFF"><b><center>$caltxt{'20'}</center></b></font></td>
  </tr>
  <tr>
    <td class="windowbg" colspan="2"><center>$caltxt{'49'}</center></td>
    <td rowspan="15"></td>
    <td class="windowbg" colspan="2"><center>$caltxt{'50'}</center></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'21'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="text" size="2" maxlength="2" name="monthspast" value="$calpast"></td>
    <td class="normal">$caltxt{'26'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="calindex" value="x"$calindex_c></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'22'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="text" size="2" maxlength="2" name="monthsfuture" value="$calfuture"></td>
    <td class="normal">$caltxt{'46'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="text" size="2" maxlength="2" name="displayevents" value="$displayevents"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'23'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="text" size="2" maxlength="2" name="modwidth" value="$calwidth"></td>
    <td class="normal">$caltxt{'47'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="minical" value="x"$minical_c></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'28'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="dayoffset" value="x"$dayoffset_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'43'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="caltop" value="x"$caltop_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'31'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="show_birthdays" value="x"$show_birthdays_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'29'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="red_sundays" value="x"$red_sundays_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'30'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="floating_calendar" value="x"$floating_calendar_c></td>
    <td class="windowbg" colspan="2"><center>$caltxt{'51'}</center></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'25'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="enableguest" value="x"$calguest_c></td>
    <td class="normal">$caltxt{'44'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="onemonth" value="x"$onemonth_c></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'27'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="allowprivate" value="x"$allowprivate_c></td>
    <td class="normal">$caltxt{'48'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="hlightday" value="x"$hlightday_c></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'32'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="admincalendar" value="x"$admincalendar_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'52'}</td>
    <td class="normal" align="center" valign="middle"><input class="input" type="checkbox" name="SMI" value="x"$SMI_c></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="catbg" colspan="5" align="center"><a href='$cgi;action=calhol'>Add/Edit/Del/View Holidays</a></td>
    <td class="normal"></td>
    <td class="normal"></td>
    <td class="normal"></td>
  </tr>
  <tr>
    <td class="normal" colspan="5" align="center" valign="middle">
      <input class="input" type="submit" name="changecal" value="$txt{'328'}" align="center" valign="middle">
      <input class="input" type="reset" value="$txt{'278'}" align="center" valign="center">
    </td>
  </tr>
</table>
</form>
							
<form action="$cgi;action=calendar8" method="post" name="caldeleteold" onSubmit="submitonce(this);">
<table align="center" border="0" cellspacing="1" cellpadding=4>
  <tr border=1>
    <td class="catbg" colspan="2">$caltxt{'37'}</td>
  </tr>
  <tr>
    <td class="normal">$caltxt{'24'}</td>
    <td class="normal"><input class="input" type="text" size="3" maxlength="3" name="caldeletedays" value="90"></td>
  </tr>
  <tr>
    <td class="normal" colspan="2" align="center" valign="middle">
      <input class="input" type="submit" name="delcaldays" value="$caltxt{'41'}" align="center" valign="center">
      <input class="input" type="reset" value="$txt{'278'}" align="center" valign="center">
    </td>
  </tr>
</table>
</form>

<p align="center"><a href=$cgi;action=admin>$txt{'193'}</a></p>
~;
	$yytitle = $caltxt{'20'};
	&template;
	exit;
}

sub cal_save_settings {
	&is_admin;
	$calpast=$FORM{'monthspast'};
	$calfuture=$FORM{'monthsfuture'};
	$calwidth=$FORM{'modwidth'};
	$displayevents=$FORM{'displayevents'};
	$displaycaltop=$FORM{'displaycaltop'};
	$guestallow=$FORM{'enableguest'};
	$calindex=$FORM{'calindex'};
	$caltop=$FORM{'caltop'};
	$onemonth=$FORM{'onemonth'};
	$hlightday=$FORM{'hlightday'};
	$allowprivate=$FORM{'allowprivate'};
	$dayoffset=$FORM{'dayoffset'};
	$red_sundays=$FORM{'red_sundays'};
	$floating_calendar=$FORM{'floating_calendar'};
	$show_birthdays=$FORM{'show_birthdays'};
	$admincalendar=$FORM{'admincalendar'};
	$minical=$FORM{'minical'};
	$SMI=$FORM{'SMI'};
	$BMC=$FORM{'BMC'};
	$HMC=$FORM{'HMC'};
	$NMC=$FORM{'NMC'};
	$BYC=$FORM{'BYC'};
	$HYC=$FORM{'HYC'};
	$NYC=$FORM{'NYC'};

    if ($calpast < 0) {
		$calpast = 0;
		push(@information,$caltxt{'33'});
	}
	if ($calfuture <= 0 ) {
		$calfuture = 1;
		push (@information,$caltxt{'34'});
	}
	if ($calwidth <= 0) {
		$calwidth=1;
		push (@information,$caltxt{'35'});
	}
  if ($displayevents < 0 ) {
		$displayevents = 0;
	}
	
	$displaycaltop = $displaycaltop eq "x" ? 1 : 0;
	$calguest = $guestallow eq "x" ? 1 : 0;
	$calindex = $calindex eq "x" ? 1 : 0;
	$allowprivate = $allowprivate eq "x" ? 1 : 0;
	$caltop = $caltop eq "x" ? 1 : 0;
	$onemonth = $onemonth eq "x" ? 1 : 0;
	$hlightday = $hlightday eq "x" ? 1 : 0;
	$admincalendar = $admincalendar eq "x" ? 1 : 0;
	$dayoffset = $dayoffset eq "x" ? 1 : 0;
	$red_sundays = $red_sundays eq "x" ? 1 : 0;
	$floating_calendar = $floating_calendar eq "x" ? 1 : 0;
	$show_birthdays = $show_birthdays eq "x" ? 1 : 0;
	$minical = $minical eq "x" ? 1 : 0;
	$SMI = $SMI eq "x" ? 1 : 0;
	$BMC = $BMC eq "x" ? 1 : 0;
	$HMC = $HMC eq "x" ? 1 : 0;
	$NMC = $NMC eq "x" ? 1 : 0;
	$BYC = $BYC eq "x" ? 1 : 0;
	$HYC = $HYC eq "x" ? 1 : 0;
	$NYC = $NYC eq "x" ? 1 : 0;

	unlink("$vardir/calendar/calsettings.txt");
	fopen(FILE,">$vardir/calendar/calsettings.txt",1);
	if ($onemonth == 1) {
	print FILE "0\n";
	}else {
	print FILE $calpast."\n";
	}
	print FILE $calfuture."\n";
	print FILE $calwidth."\n";
	print FILE $displayevents."\n";
	print FILE $dayoffset."\n";
	print FILE $caltop."\n";
	print FILE $calindex."\n";	
	print FILE $displaycaltop."\n";
	print FILE $onemonth."\n";
	print FILE $hlightday."\n";
	print FILE $red_sundays."\n";
	print FILE $floating_calendar."\n";
	print FILE $show_birthdays."\n";
	print FILE $calguest."\n";
	print FILE $allowprivate."\n";
	print FILE $admincalendar."\n";
	print FILE $minical."\n";
	print FILE $SMI."\n";
	print FILE $BMC."\n";
	print FILE $HMC."\n";
	print FILE $NMC."\n";
	print FILE $BYC."\n";
	print FILE $HYC."\n";
	print FILE $NYC."\n";
	close(FILE);

	foreach $information (@information)
		{$yymain .= "$information ";}
	$yymain .= qq~
$caltxt{'36'}<p align="center"><a href=$cgi;action=admin>$txt{'193'}</a></p>
~;
	$yytitle = $caltxt{'1'};
	&template;
	exit;
}

sub cal_delete_messages {
	&is_admin;
	if($settings[7] ne "Administrator")
		{ &fatal_error("$txt{'1'}"); }
	&timeformat($date);
	($curm, $curd, $cury) = split(/\//, $date);
	($cury, $trash) = split(/ /, $cury);
	$daysdelete=$FORM{'caldeletedays'};
	$curdateno = ($cury*365)+($curm*30)+$curd;
	$deletedateno = $curdateno-$daysdelete;
	open (FILE,"$vardir/calendar/calendar.txt");
	@calendar=<FILE>;
	close(FILE);
	$delcount=0;
	foreach $calentry (@calendar) {
		$yy=substr($calentry,2,2);
		$mm=substr($calentry,4,2);
		$dd=substr($calentry,6,2);
		$caldateno = ($yy*365)+($mm*30)+$dd;
		if ($caldateno >= $deletedateno)
			{push (@donotdelete,$calentry);}
		else {
			$filename=substr($calentry,0,8).".evt";
			unlink("$vardir/calendar/$filename");
			$delcount++;
		}
	}
	if ($delcount != 0) {
		unlink ("$vardir/calendar/calendar.txt");
		fopen (FILE,">$vardir/calendar/calendar.txt",1);
		print FILE @donotdelete;
		close(FILE);
	}
	$yymain .= qq~
<center>$delcount $caltxt{'38'}.</center>
<p align="center"><a href=$cgi;action=admin>$txt{'193'}</a></p>
~;
	$yytitle=$caltxt{'1'};
	&template;
	exit;
}

sub make_note_array {
	open(FILE, "$vardir/calendar/calendar.txt");
	@calendar = <FILE>;
	close(FILE);
	open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	close(FILE);

	foreach $calentry (@calendar) {
		chomp $calentry;
		$datas = 0;
		$data = "";
		open(CALFILE, "$vardir/calendar/$calentry.evt") || die "Cannot open file $filename";
		while (<CALFILE>) {
			chomp;
			if ($datas > 0) {$data .= "::";}
			($message,$composer,$private) = split(/\|/);
			if (($allowprivate==0) || (($allowprivate==1) && (($private == 0) || ($composer eq $username) || ($settings[7] eq "Administrator")))) {
				$data .= $message;
				$datas++;
			}
		}
		close(CALFILE);
		if (length($data)>0)
			{push(@all_events, $calentry."NO".$data);}
	}

	if ($yearstart) {
		$first_noted_year = $yearstart;
		$last_noted_year = $yearstart+(int($displaymonths/12)+1);
	} elsif ($year)
		{$first_noted_year = $last_noted_year = $year;}

	if ($show_birthdays == 1) {
		@all_events = sort @all_events;
		foreach $usernames (@members) {
			chomp $usernames;
			open(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			close(FILE);
			chomp $userbd[1];
			chomp $userbd[16];
			if ($userbd[16]) {
				($usermonth, $userday, $useryear) = split(/\//, $userbd[16]);
				$string = (length($usermonth) == 1) ? "0$usermonth" : $usermonth;
				$string .= (length($userday) == 1) ? "0$userday" : $userday;
				$string .= "BD$userbd[1]::$useryear";
				for ($ayear = $first_noted_year ; $ayear <= $last_noted_year ; $ayear++) {
					push (@all_events, $ayear.$string);
	}	}	}	}

	if (open(HOLIDAYS, "$vardir/calendar/holidays.txt")) {
		@holidays = <HOLIDAYS>;
		close(HOLIDAYS);
		foreach $holiday (@holidays) {
			chomp $holiday;
			($holi_date, $holi_day) = split(/\|/, $holiday);
			if (length($holi_date) == 8) {
				push (@all_events, $holi_date."HO".$holi_day);
			} else {
				for ($ayear = $first_noted_year ; $ayear <= $last_noted_year ; $ayear++)
					{push (@all_events, $ayear.$holi_date."HO".$holi_day);}
	}	}	}

	@all_events = sort @all_events;
}

sub get_event {
	$nextnote = shift(@all_events);
	if ($nextnote) {
		$n_year = substr($nextnote,0,4);
		$n_month = substr($nextnote,4,2);
		$n_day = substr($nextnote,6,2);
		$n_date = substr($nextnote,2,6);
		$n_type = substr($nextnote,8,2);
		$n_data = substr($nextnote,10);
	} else
		{$nextnote = 0;}
}

sub get_settings {
	open(FILE,"$vardir/calendar/calsettings.txt");
	@calsettings=<FILE>;
	close(FILE);
	$calpast=(@calsettings[0])?@calsettings[0]:4; 
	$calfuture=(@calsettings[1])?@calsettings[1]:8;
	$calwidth=(@calsettings[2])?@calsettings[2]:3;
	$displayevents=(@calsettings[3])?@calsettings[3]:0;
	$dayoffset=(@calsettings[4])?@calsettings[4]:0;
	$caltop=(@calsettings[5])?@calsettings[5]:1;
	$calindex=(@calsettings[6])?@calsettings[6]:1;
	$displaycaltop=(@calsettings[7])?@calsettings[7]:0;
	$onemonth=(@calsettings[8])?@calsettings[8]:0;
	$hlightday=(@calsettings[9])?@calsettings[9]:1;
	$red_sundays=(@calsettings[10])?@calsettings[10]:1;
	$floating_calendar=(@calsettings[11])?@calsettings[11]:0;
	$show_birthdays=(@calsettings[12])?@calsettings[12]:1;
	$calguest=(@calsettings[13])?@calsettings[13]:0;
	$allowprivate=(@calsettings[14])?@calsettings[14]:1;
	$admincalendar=(@calsettings[15])?@calsettings[15]:0;
	$minical=(@calsettings[16])?@calsettings[16]:0;
	$SMI=(@calsettings[17])?@calsettings[17]:0;
	$BMC=(@calsettings[18])?@calsettings[18]:0;
	$HMC=(@calsettings[19])?@calsettings[19]:0;
	$NMC=(@calsettings[20])?@calsettings[20]:0;
	$BYC=(@calsettings[21])?@calsettings[21]:0;
	$HYC=(@calsettings[22])?@calsettings[22]:0;
	$NYC=(@calsettings[23])?@calsettings[23]:0;
}

sub calendar_index {
	# "Open" the table
	$yymain .= qq~
	<tr>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg"><b>$caltxt{'1'}</b>
	~;
	if ($displayevents > 0) {$yymain .= qq~ $caltxt{'45a'}$displayevents $caltxt{'45b'}~;}
	$yymain .= qq~	    
	    </font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/calendar2.gif" border="0" width="20" height="17"></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">
	~;

	($secx,$minx,$hourx,$ddx,$mmx,$yyx,$tmpx,$tmpx,$tmpx) = localtime(time + (86400*$displayevents));
	$mmx = $mmx + 1;
	$yyx = ($yyx % 100);
	$yyx = ($yyx < 10) ? "0".$yyx : $yyx;
	$date2 = $mmx."/".$ddx."/".$yyx." at 00:00:00";
	$date2 = stringtotime($date2);

	# Get Calendar Notes
	fopen(FILE, "$vardir/calendar/calendar.txt") || die "$txt{'23'} - $vardir/calendar/calendar.txt";
	@calendar=<FILE>;
	fclose(FILE);
	require "$sourcedir/Subs.pl";
	&timeformat($date);
	($curmon, $curday, $curyear) = split(/\//, $date);
	($curyear, $trash) = split(/ /, $curyear);
	$calcount=0;


	if ($displayevents == 0) {
		# Display the amount of Calendar notes
		if ($calcount == 0) {
			$yymain .= qq~$caltxt{'3'}~;
		} elsif ($calcount == 1) {
			$yymain .= qq~<a href="$cgi;action=calendar3;viewday=20$cury$curm$curd">$calcount $caltxt{'4'}. </a>~;
		} elsif ($calcount >= 2) {
			$yymain .= qq~<a href="$cgi;action=calendar3;viewday=20$cury$curm$curd">$calcount $caltxt{'5'}. </a>~;
		}
	}

	foreach $calentry (sort @calendar) {
		$yy=substr($calentry,2,2);
		$mm=substr($calentry,4,2);
		$dd=substr($calentry,6,2);

		$date1=$mm."/".$dd."/".$yy." at 00:00:00";
		$date1 = stringtotime($date1);
		$result = ($date2 - $date1) / 86400;
		
			if ((($displayevents == 0) && (($dd == $curday) && ($mm == $curmon) && ($yy == $curyear))) ||
			(($displayevents > 0) && (($result >= 0) && ($result <= $displayevents)))) {
			
			$filename="20".$yy.$mm.$dd.".evt";
			open (FILE,"$vardir/calendar/$filename");
			@daysevents=<FILE>;
			close(FILE);
			foreach $event (sort @daysevents) {

				if ($displayevents > 0) {
					($message,$postuser,$calprivate) = split( /\|/, $event);
					$preubbcmessage=$message;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					$message =~ s~(\S{80})(?=\S)~$1\n~g;
					if($calcount >= 1) {	
						$yymain .= qq~ <HR SIZE=1 NOSHADE>
						~;
					}

					$yymain .= qq~<a href="$cgi;action=calendar3;viewday=20$yy$mm$dd">$mm/$dd/20$yy</a> : $message - ~;
					if(!$yyUDLoaded{$postuser}) { &LoadUser($postuser); }
					if(exists $userprofile{$postuser}) {
						$yymain .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$postuser}">$userprofile{$postuser}->[1]</a>~;
					}
					else {
						$yymain .= qq~ $postuser
						~;
					}
				}
				$calcount++;
			}
		}
	}

	if ($show_birthdays == 1) {
		# Get Birthdays
		fopen(FILE, "$memberdir/memberlist.txt") || die "$txt{'23'} - $memberdir/memberlist.txt";
		@members = <FILE>;
		fclose(FILE);
		foreach $usernames (@members) {
			chomp $usernames;
			$mem = $members;
			fopen(FILE, "$memberdir/$usernames.dat") || die "$txt{'23'} - $memberdir/$usernames.dat";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
			($matchmon, $matchday, $matchyear) = split(/\//, $userbd[16]);
						
			if ($matchday >= 1) {

				if (($matchmon < $curmon) || (($matchmon == $curmon) && ($matchday < $curday))) {
					$newy = $curyear + 1;
				}
				else {
					$newy = $curyear;
				}
		
				$date1=$matchmon."/".$matchday."/".$newy." at 00:00:00";
				$date1 = stringtotime($date1);
				$result = ($date2 - $date1) / 86400;

				if ((($displayevents == 0) && (($matchmon == $curmon) && ($matchday == $curday))) ||
					(($displayevents > 0) && (($result >= 0) && ($result <= $displayevents)))) {

					if($calcount >= 1) {
						$yymain .= qq~ <HR SIZE=1 NOSHADE>
						~;
					}

					($matchyear, $trash) = split(/ /, $matchyear);
					$age = 2000 + $newy - $matchyear;
					$yymain .= qq~
					$matchmon/$matchday/20$newy : <a href="$scripturl?action=viewprofile;username=$usernames">$userbd[1]</a> $caltxt{'17'} $age $caltxt{'18'}~;
				}
				$calcount++;
			}
    		}
	}

	$show_holidays = 1;
	if ($show_holidays == 1) {
		open(HOLIDAYS, "$vardir/calendar/holidays.txt") || die "$txt{'23'} - $vardir/calendar/holidays.txt";
		@holidays = <HOLIDAYS>;
		close(HOLIDAYS);
		foreach $holiday (sort @holidays) {
			($holi_date, $holi_day) = split(/\|/, $holiday);

			if (length($holi_date) == 8)
			{
			$yy=substr($holi_date,2,2);
			$mm=substr($holi_date,4,2);
			$dd=substr($holi_date,6,2);
			}
			elsif (length($holi_date) == 4)
			{
			$mm=substr($holi_date,0,2);
			$dd=substr($holi_date,2,2);
			$yy=$curyear;
			}

			$date1=$mm."/".$dd."/".$yy." at 00:00:00";
			$date1 = stringtotime($date1);
			$result = ($date2 - $date1) / 86400;
		
				if ((($displayevents == 0) && (($dd == $curday) && ($mm == $curmon) && ($yy == $curyear))) ||
				(($displayevents > 0) && (($result >= 0) && ($result <= $displayevents)))) {

			if ($displayevents > 0) {
			if($calcount >= 1) {$yymain .= qq~ <HR SIZE=1 NOSHADE>~;}

			$yymain .= qq~<a href="$cgi;action=calendar3;viewday=20$yy$mm$dd">$mm/$dd/20$yy</a> : $holi_day ~;
				}
			$calcount++;
			}
		}
	}



	if($calcount >= 1) {$yymain .= qq~ <HR SIZE=1 NOSHADE>~;}
	$yymain .= qq~
	$txt{'791'} <a href="$cgi;action=calendar">$caltxt{'1'}</a>
         </font></td>
~;
if ($minical == 1)
{
$yymain .= qq~<td width="1">~;&minical;$yymain .= qq~</td>~;
}

$yymain .= qq~
          </tr>
        </table>
    </font></td>
  </tr>
	~;
}

sub minical {
	use Time::Local;
$calpast = 0;
$calfuture = 1;
	($secA,$minA,$hourA,$mdayA,$monA,$yearA,$wdayA,$ydayA,$isdstA) = localtime(time + (3600*($timeoffset+$settings[18])));
	$yearstart = $yearA+1900;
	$displaymonths=$calpast+$calfuture;
	$monthstart=1+$monA-$calpast;
	$monthend=1+$monA+$calfuture;
	while ($monthstart <= 0) {
		$monthstart+=12;
		$yearstart-=1;
	}
	&make_note_array;
	&get_event;
	while (($nextnote) && (($n_year < $yearstart) || (($n_year == $yearstart) && ($n_month < $monthstart))))
		{&get_event;}

	$yymain .= "<table width=\"100%\" cellspacing=\"5\">\n<tr>\n<td valign=top>";
	for ($z=0; $z<$displaymonths; $z++) {
		$displayyear=$yearstart;
		$displaymonth=$monthstart+$z;
		while ($displaymonth >= 13) {
			$displaymonth-=12;
			$displayyear++;
		}
		if (length($displayyear)== 1) {$displayyear="0$displayyear";}
		if (length($displaymonth)== 1) {$displaymonth="0$displaymonth";}
		if (($z+1)%$calwidth == 1 && $z >= 1)
			{$yymain .= "</td>\n  </tr>\n  <tr>\n    <td valign=top>";}
		elsif ($z > 0)
			{$yymain .= "</td>\n    <td valign=top>";}
			&minidraw;
		}
	$yymain .= "</table>";	
}

sub minidraw {
	$yytitle = "$txt{'18'}";
	$mon = $displaymonth-1;
	$year = $displayyear;
	$days_in_month = &days_in_month();
	($temp,$temp,$temp,$temp,$temp,$temp,$wday,$temp,$temp) = localtime(timegm(0,0,0,1,$mon,$year));
	$pvm = 1-$wday;
	if ($dayoffset == 1) # Offset
		{$pvm--;}
@months2 = ('January','February','March','April','May','Jun','July','August','September','October','November','December');
	$displayyear=substr($displayyear,-2);
#	$monthyear = @months2[$mon]." ".$year;
	$monthyear1 = @months2[$mon];
	$monthyear2 = " ".$year;
	$yymain .= qq~
<TABLE WIDTH=100 CELLSPACING=0 CELLPADDING=0 BORDER=1 COLS=7>
  <TR HEIGHT=19>
     <TD COLSPAN=7 CLASS="catbg" ALIGN=center VALIGN=middle height="19">
	<A HREF="$cgi;action=calendar2;viewmonth=$displaymonth;viewyear=$displayyear" TITLE="$caltxt{'6'} $monthyear1$monthyear2">$monthyear1$monthyear2</A>
    </TD>
  </TR>
  <TR HEIGHT=19>
~;
	
	for ($i=0;$i<7;$i++)
	{$yymain .= "<TD CLASS=\"titlebg\" WIDTH=17 align=center valign=middle height=19>".substr(@days[$i],0,2)."</TD>\n";}
	$yymain .= "  </TR>\n";

	while ($pvm <= $days_in_month) {

		$yymain .= "  <TR HEIGHT=19>\n";
		for ($weekdaycounter=0;$weekdaycounter<7;$weekdaycounter++) {
			if ($pvm >= 1 && $pvm <= $days_in_month) {
				$displayday = $pvm < 10 ? "0".$pvm : $pvm;
				$paivays = $displayyear.$displaymonth.$displayday;

				$class = "normal";
				$pvm_text = $pvm;
				$number = $pvm;
				$pvm_seq = &serial_number();
				$style = "";

				DATECHECK3:
				if (($nextnote) && ($n_date eq $paivays)) {
				    if ($SMI == 1) {					
					if ($n_type eq "BD") {
						$style .= " background-image:URL('$imagesdir/birthday_small.gif'); background-repeat:no-repeat;";
						$class = "birthday";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "HO") {
						$style .= " background-image:URL('$imagesdir/holiday_small.gif'); background-repeat:no-repeat;";
						$class = "note";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "NO") {
						$style .= " background-image:URL('$imagesdir/note_small.gif'); background-repeat:no-repeat;";
						$class = "note";
						$pvm_text = "$pvm";
					}
				    } else {
					if ($n_type eq "BD") {
						$class = "birthday";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "HO") {
						$class = "note";
						$pvm_text = "$pvm";
					} elsif ($n_type eq "NO") {
						$class = "note";
						$pvm_text = "$pvm";
					}
				    }
					&get_event;
					goto DATECHECK3;
				}
				elsif (($mdayA == $pvm) && (($monA+1) == $displaymonth) && (($yearA-100) == $displayyear)) {
					$class = "today";
					$pvm_text = "<U>".$pvm_text."</U>";
				}
				$pvm_text = (($red_sundays == 1) && ($weekdaycounter == 0)) ? "<FONT COLOR=#FF0000> ".$pvm_text." </FONT>" : " ".$pvm_text." ";
				$day_link = qq~<A HREF="$cgi;action=calendar3;viewday=20$paivays" TITLE="$txt{'305'} $monthyear1 $pvm_seq$monthyear2">$pvm_text</A>~;
				$yymain .= "    <TD CLASS=\"$class\" STYLE=\"$style\" HEIGHT=\"16\" WIDTH=\"30\" ALIGN=\"center\" VALIGN=\"middle\">$day_link</TD>";
			}
			elsif ($floating_calendar == 1)
				{$yymain .= "    <TD HEIGHT=\"1\" WIDTH=\"30\"></TD>\n";}
			else
				{$yymain .= "    <TD CLASS=\"normal\" HEIGHT=\"1\" WIDTH=\"30\"> </TD>\n";}
			$pvm++;
		}
		$yymain .= "  </TR>\n";
	}
$yymain .= "</table>";
}

sub calhol {
	&is_admin;
	$yytitle = "holidays";
	$database="$vardir/calendar/holidays.txt";

	if ($input{'database'} eq ''){
		$db=$database;
	}else{
		$db=$input{'database'};
	}

	open (ORGDB,"<$database");
	@ODB=<ORGDB>;
	close (ORGDB);
	$yymain .= qq~
		<center>
		<font face='Arial' size='2'>
		<h1><i>$caltxt{'53'}</i></h1>
		<SCRIPT LANGUAGE="JavaScript1.2" SRC="$ubbcjspath" TYPE="text/javascript"></SCRIPT>
		<table border='1'>
		<tr>
		<td colspan="2" CLASS="catbg"><font size='2'>Actions</font></td>
		<td CLASS="catbg"><font size='2'>$txt{'317'} $caltxt{'55'}</font></td>
		<td CLASS="catbg"><font size='2'>$caltxt{'39'}</font></td></tr>
	~;
	foreach $rec (@ODB){
		chomp($rec);
		($date,$day)=split(/\|/,$rec);
			if (length($date) == 8){
				$yy=substr($date,0,4);
				$mm=substr($date,4,2);
				$dd=substr($date,6,2);
				$event="$yy/$mm/$dd";
			}
			elsif (length($date) == 4){
				$mm=substr($date,0,2);
				$dd=substr($date,2,2);
				$yy="";
				$event="$mm/$dd";
			}
		$yymain .= qq~
			<tr><td width="2%" CLASS="catbg">
			<font size='2'>
			<form action="$cgi;action=calhol3" method="POST" name="calholadd" onSubmit="submitonce(this);">
			<input type='hidden' name='date' value='$date'>
			<input type='hidden' name='day' value='$day'>
			<input class="input" type="submit" value="$caltxt{'57'}" align="center" valign="middle">
			</form>
			</td><td width="2%" CLASS="catbg">
			<form action="$cgi;action=calhol2" method="POST" name="calholadd" onSubmit="submitonce(this);">
			<input type='hidden' name='calhol' value='delete'>
			<input type='hidden' name='date' value='$date'>
			<input type='hidden' name='day' value='$day'>
			<input class="input" type="submit" value="$caltxt{'58'}" align="center" valign="middle">
			</form>
			</td><td width="30%" CLASS="catbg">$event</td><td width="40%" CLASS="catbg">$day</td></tr></font></center>
		~;
	}
	$yymain .= qq~
		</table>
		<center>
		<form action="$cgi;action=calhol2" method="POST" name="calholadd" onSubmit="submitonce(this);">
		<input type='hidden' name='calhol' value='add'>
		<table border='1'>
		<tr><td CLASS="catbg"><font size='2'>$txt{'317'}</td><td CLASS="catbg"><input type='text' name='nyear' size="4" maxlength="4">/<input type='text' name='nmonth' size="2" maxlength="2">/<input type='text' name='ndate' size="2" maxlength="2">$caltxt{'55'}</td></tr>
		<tr><td CLASS="catbg"><font size='2'>$caltxt{'59'}</font></td><td CLASS="catbg"><input type='text' name='nday'></td></tr>
		</table>
		<input class="input" type="submit" value="$caltxt{'56'} $caltxt{'39'}" align="center" valign="middle">
		</form></center>
	~;
	&template;
	exit;
}

sub calholdeladd {
	&is_admin;
	$database="$vardir/calendar/holidays.txt";
	open (ORGDB,"<$database");
	@ODB=<ORGDB>;
	close (ORGDB);
	open (DATABASE,">$database");
	@DB=<DATABASE>;
		foreach $rec (@ODB){
			chomp($rec);
			($date,$day)=split(/\|/,$rec);
			if ($date eq $FORM{'date'} && $day eq $FORM{'day'}){
				print DATABASE "$FORM{'ndate'}|$FORM{'nday'}\n";
			}else{
				print DATABASE "$date|$day\n";
			}
		}
	close (DATABASE);
	if ($FORM{'calhol'} eq 'add'){
		if ($FORM{'nyear'} eq ''){
			open (DATABASE1,">>$database");
			print DATABASE1 "$FORM{'nmonth'}$FORM{'ndate'}|$FORM{'nday'}\n";
			close (DATABASE1);
		}else {
			open (DATABASE1,">>$database");
			print DATABASE1 "$FORM{'nyear'}$FORM{'nmonth'}$FORM{'ndate'}|$FORM{'nday'}\n";
			close (DATABASE1);
		}
	}
	if ($FORM{'calhol'} eq 'delete'){
		open (DATABASE,">$database");
		@DB=<DATABASE>;
		foreach $rec (@ODB){
			chomp($rec);
			($date,$day)=split(/\|/,$rec);
			if ($date eq $FORM{'date'} && $day eq $FORM{'day'}){
				print DATABASE "";
			}else{
				print DATABASE "$date|$day\n";
			}
			}
		close (DATABASE);
	}
	$yySetLocation = qq~$cgi;action=calhol~;
	&redirectexit;
	&template;
	exit;
}

sub calholedit {
	&is_admin;
	$yymain .= qq~
		<SCRIPT LANGUAGE="JavaScript1.2" SRC="$ubbcjspath" TYPE="text/javascript"></SCRIPT>
		<form action="$cgi;action=calhol2" method="POST" name="calholedit" onSubmit="submitonce(this);">
		<input type='hidden' name='date' value='$FORM{'date'}'>
		<input type='hidden' name='day' value='$FORM{'day'}'>
		<table border='1'>
		<tr><td CLASS="catbg"><font size='2'>$txt{'317'}</font></td><td CLASS="catbg"><input type='text' name='ndate' value='$FORM{'date'}'></td></tr>
		<tr><td CLASS="catbg"><font size='2'>$caltxt{'59'}</font></td><td CLASS="catbg"><input type='text' name='nday' value='$FORM{'day'}'></td></tr>
		</table>
		<input class="input" type="submit" value="$caltxt{'57'} $caltxt{'39'}" align="center" valign="middle">
		</form>
	~;
	&template;
	exit;
}

1;